## Verity Sample Static QR Code Lab App

This is a sample application that demonstrates Lab App API integration with a [static QR code approach](https://gitlab.com/evernym/verity/lab-app-integration-guide#option-3-static-qr-codes).
>DISCLAIMER: This is a sample application, and it isn't meant to be used in production. There are some disadvantages like ngrok tunnels that time out, and in-memory storage that stores user data only while this app is up and running. 

### Launching the application Locally

Requirements:
- You have received Domain DID, REST API key and Credential Definition Id from Evernym
- You have NodeJs v12 or later installed
- You have ngrok installed ([https://ngrok.com/](https://ngrok.com/)).
> NOTE: Ngrok is used to create a public webhook URL which will forward response messages from Verity Application Server to the web app. If you have capabilities to start the application on a public IP address then you don't need ngrok]

To try out the application follow these steps:

- In a separate terminal window start ngrok for port 4000 and leave it running:
```sh
ngrok http 4000
```
- Install required NodeJs packages:
```sh
npm install
```
- Start the app
```sh
node app.js
```

- Fill in values for VERITY_URL, DOMAIN_DID, X_API_KEY (you should have received these inputs from Evernym), and WEBHOOK_URL into **.env** file in the current folder. A properly filled **.env** file should have this format:
```sh
VERITY_URL=https://vas.pps.evernym.com
DOMAIN_DID=Abcdefghijklmnopqrstuv
X_API_KEY=ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqr:abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789abcdefghijklmnopqrstuvwxyz
CRED_DEF_ID=aBCDEFGHIJKLMNOPQRSTUV:3:CL:123456:latest
WEBHOOK_URL=https://2cdfa95b3ed5.ngrok.io/webhook
```
> NOTE: These are just sample reference values. These values will NOT work if left unchanged. You should specify DOMAIN_DID, X_API_KEY and CRED_DEF_ID that you received from Evernym

The application will be available on http://localhost:4000

Generate Static QR Code and scan it with Camera app or some QR Code Scanner app. [Here](#generating-static-qr-code) you can see how to generate a QR Code.

### Launching the application using Docker

Requirements:
- You have received Domain DID, REST API key and Credential Definition Id from Evernym
- You have Docker installed

To start the app follow these steps:
- Fill in values for VERITY_URL, DOMAIN_DID and X_API_KEY (you should have received these inputs from Evernym) into **.env** file in the current folder. A properly filled **.env** file should have this format:
```sh
VERITY_URL=https://vas.pps.evernym.com
DOMAIN_DID=Abcdefghijklmnopqrstuv
X_API_KEY=ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqr:abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789abcdefghijklmnopqrstuvwxyz
CRED_DEF_ID=aBCDEFGHIJKLMNOPQRSTUV:3:CL:123456:latest
```
> NOTE: These are just sample reference values. These values will NOT work if left unchanged. You should specify DOMAIN_DID, X_API_KEY and CRED_DEF_ID that you received from Evernym
- Create a docker image with pre-installed requirements. Run this command from the current folder:
```sh
docker build -t static-qr-code-demo-lab-app .
```
Start a Docker container:
```sh
docker run -p 4000:4000 --env-file .env -it static-qr-code-demo-lab-app
```

The application will be available on http://localhost:4000

Generate Static QR Code and scan it with Camera app or some QR Code Scanner app. [Here](#generating-static-qr-code) you can see how to generate a QR Code.


### Generating Static QR Code

A static QR code should be created from the URL in the following format:

For PROD Travel Pass:
- https://home.prod.travelpassinfra.org/?itp_url=<staticURL>&sender=sender&route=1

For Staging Travel Pass:
- https://home.staging.travelpassinfra.org/?itp_url=<staticURL>&sender=sender&route=1

In this app, as it uses Staging Net, static QR Code URL should be created like this:
- https://home.staging.travelpassinfra.org/?itp_url=<your_ngrok_address/generate-proof-request>&sender=sender&route=1

Example of static QR Code URL:
- https://home.staging.travelpassinfra.org/?itp_url=https://ae25-178-220-107-20.ngrok.io/generate-proof-request&sender=sender&route=1

You can use any QR code generator (e.g. https://www.qr-code-generator.com/).


© 2013-2021, ALL RIGHTS RESERVED, EVERNYM INC.
